<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';


require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

require_once $base_path_to_learning .'students_api/modules/dashboard/student_dashboard_function.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or 
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;
$class_id = $jwt_validate->data->class;
$section_id = $jwt_validate->data->section;

$specific_db_name = validateStudentAcess($conn_rjllearning, $role, $workspace_id, ["student"], null, null, $userid);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}
validateStudentClassSection($conn_rjllearning_specific, $userid, $institution_id, $branch_id, $class_id, $section_id);




if ($postdata['function_type'] == "fetch_student_dashboard") {

    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }

    if(isset($postdata['subject_id']) and !empty($postdata['subject_id']) and trim($postdata['subject_id'])) {
        $subject_id = trim($postdata['subject_id']);
    } else {
        $subject_id = null;
    }
 
    if (isset($postdata['search_string']) and !empty($postdata['search_string'])  and ($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }
     if (isset($postdata['from_date']) and !empty($postdata['from_date'])) {
        $from_date = trim($postdata['from_date']);
    } else {
        $from_date = null;
    }
    if (isset($postdata['to_date']) and !empty($postdata['to_date'])) {
        $to_date = trim($postdata['to_date']);
    } else {
        $to_date = null;
    }
    
    if ($from_date > $to_date) {
    errorreturn('Invalid Date format');
    }

    
    
    $assignments = getSpecificAssignment(
        $conn_rjllearning_specific,
        $institution_id,
        $search_string,
        $branch_id,
        $class_id,
        $section_id,
        $subject_id,
        $userid
    );

    $homework = getStudentsHomework(
        $conn_rjllearning_specific,
        $institution_id,
        $search_string,
        $branch_id,
        $subject_id,
        $class_id,
        $section_id,
        $from_date,
        $to_date
    );
    $timetable=fetchStudentTimetableWithClassSection($conn_rjllearning_specific, $institution_id, $search_string, $branch_id, $userid );
  
     $announcment=getAnnouncement($conn_rjllearning_specific, $institution_id, $branch_id, $class_id, $section_id, $search_string, $from_date, $to_date);
    $activity=getActivity_detailsforStudents($conn_rjllearning_specific, $institution_id, $branch_id, $search_string, $class_id, $section_id, $userid);
    $live_meeting=fetchExistingMeetings($conn_rjllearning_specific, $institution_id, $branch_id, $subject_id, $search_string, $section_id, $class_id, $userid); 
    // $lesson=getLesson($conn_rjllearning_specific, $institution_id, $search_string, $branch_id, $subject_id, $section_id, $class_id, $from_date, $to_date, $publish_date, $author, $lesson_name)
    // Combine results into one array
    $result = [
        'live_meeting'=>$live_meeting,
        'announcement'=> $announcment,
        'timetable' =>$timetable,
        'homework' => $homework,
        'assignments' => $assignments,
        'activity'=>$activity
    ];
        
        successreturn($result);
    
}